<?php

function cnvvo($zip)
{

/**
* @return string
* @param zip string
* @desc Returns VO (country) name using ZIP code of MDS
*/

  $tlconvert = array
    (
     "B"   => "Belgium",
     "CA"  => "Canada",
     "CH"  => "Switzerland",
     "DK"  => "Denmark",
     "EE"  => "Estonia",
     "FI"  => "Finland",
     "FIN" => "Finland",
     "SF"  => "Finland",
     "HU"  => "Hungary",
     "JP"  => "Japan",
     "LT"  => "Lithuania",
     "LI"  => "Lithuania",
     "NL"  => "The Netherlands",
     "NO"  => "Norway",
     "N"   => "Norway",
     "RU"  => "Russia",
     "RF"  => "Russia",
     "SE"  => "Sweden",
     "KEK"  => "Japan",
     "TOKYO"  => "Japan"
     );

  $zparts = explode("-",$zip);
  $tlcode = trim($zparts[0]);
  $match  = ( $tlconvert[$tlcode] ) ? $tlconvert[$tlcode] : "World";
  return $match;

}
function add_country($cllist)
{

  if ( !defined("OBJ_CLUS") ) define("OBJ_CLUS","nordugrid-cluster");
  if ( !defined("CLU_ZIPC") ) define("CLU_ZIPC","nordugrid-cluster-location");
  if ( !defined("DN_LOCAL") ) define("DN_LOCAL","mds-vo-name=local,o=grid");

  $tlim = 15;
  $tout = 20;

  $conarr = array();
  $idxarr = array();

  $nclus  = count($cllist);

  for ( $l = 0; $l < $nclus; $l++ ) {
    $host   = $cllist[$l]["host"];
    $port   = $cllist[$l]["port"];
    $clconn = ldap_connect($host,$port);
    array_push($conarr,$clconn);      
    array_push($idxarr,$l);      
  }
  $listres = @ldap_list($conarr,DN_LOCAL,"(objectclass=".OBJ_CLUS.")",array(CLU_ZIPC),0,0,$tlim,LDAP_DEREF_NEVER,$tout);
  // Fall back to a conventional LDAP
  //  if ( !$listres[0] ) $listres = ldap_list($conarr,DN_LOCAL,"(objectclass=".OBJ_CLUS.")",array(CLU_ZIPC),0,0,$tlim,LDAP_DEREF_NEVER);

  $nres = count($listres);

  for ( $n = 0; $n < $nres; $n++ ) {
    $res = $listres[$n];
    $con = $conarr[$n];
    $idx = $idxarr[$n]; /* normally, $idx should be equal to $n */

    $record   = @ldap_get_entries($con,$res);
    if ( !$record ) $cllist[$idx]["zvoname"] = "<font color=red>$tout sec t/o</a>";
    $nrecords = $record["count"]; /* should be 1 */

     for ($m = 0; $m < $nrecords; $m++) {
       $curcod = $record[$m][CLU_ZIPC][0];
       $cllist[$idx]["zvoname"] = cnvvo($curcod);
     }
  }

  return($cllist);
}

?>